#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
#include "io.h"

void matriz_matriz(double **a,int fa,int ca,double **b,int fb,int cb,double **c,int fc,int cc)
{
  int i,j,k;
  double s;

  for(i=0;i<fa;i++)
  {
    for(j=0;j<cb;j++)
    {
      s=0.;
      for(k=0;k<ca;k++)
      {
        s+=a[i][k]*b[k][j];
      }
      c[i][j]=s;
    }
  }
}

main()
{
  double **a,**b,**c;
  int fa,ca,fb,cb,fc,cc;
  double l,u;
  int i;

  int ti1,tf1,si,sf;
  struct timeval *tv;
  struct timezone *tz;

  tv=(struct timeval *) malloc(sizeof(struct timeval));
  tz=(struct timezone *) malloc(sizeof(struct timezone));

  printf("De las filas y columnas de la primera matriz y las columnas de la segunda: ");
  scanf("%d",&fa);
  scanf("%d",&ca);
  fb=ca;
  scanf("%d",&cb);
  fc=fa;
  cc=cb;

  a=(double **) malloc(sizeof(double *)*fa);
  for(i=0;i<fa;i++)
    a[i]=(double *) malloc(sizeof(double)*ca);
  b=(double **) malloc(sizeof(double *)*fb);
  for(i=0;i<fb;i++)
    b[i]=(double *) malloc(sizeof(double)*cb);
  c=(double **) malloc(sizeof(double *)*fc);
  for(i=0;i<fc;i++)
    c[i]=(double *) malloc(sizeof(double)*cc);
  printf("De los valores inferior y superior: ");
  scanf("%lf %lf",&l,&u);

  generar_matriz(a,fa,ca,l,u);
  generar_matriz(b,fb,cb,l,u);
#ifdef DEBUG
  escribir_matriz(a,fa,ca);
  escribir_matriz(b,fb,cb);
#endif

  gettimeofday(tv,tz);
  si=(tv->tv_sec);
  ti1=(tv->tv_usec);
  ti1=si*1000000+ti1;

  matriz_matriz(a,fa,ca,b,fb,cb,c,fc,cc);

  gettimeofday(tv,tz);
  sf=(tv->tv_sec);
  tf1=(tv->tv_usec);
  tf1=sf*1000000+tf1;
  printf("Tamao %d: %.6lf seg \n",fa,(tf1-ti1)/1000000.);

#ifdef DEBUG
  escribir_matriz(c,fc,cc);
#endif
 
  free(tv);
  free(tz);
  for(i=0;i<fa;i++)
    free(a[i]);
  free(a);
  for(i=0;i<fb;i++)
    free(b[i]);
  free(b);
  for(i=0;i<fc;i++)
    free(c[i]);
  free(c);
}




























